void scpy(char *dest,const char *src,int size)
{
	for(int x=0;x<size;x++) dest[x]=src[x];
}

void scat(char *dest,const char *src, int size1, int size2)
{
	for(int x=0;x<size2;x++) dest[size1+x]=src[x];	
}

int slen(const char *in) //num of elements not including 0
{
	int x=0;;
	while(in[x]!=0) x++;
	return x;
}

struct string
{
	int len;
	char *str;
	
	
	string();
	~string();
	string(int size);
	string(const string & str);
	string(const char *s);
	string(char a);
	string(char a,char b);
	string(char a,char b,char c);
	string(char a,char b,char c, char d);
	string(char a,char b,char c, char d, char e);
	string(char a,char b, char c, char d, char e, char f);
	string(char a, char b, char c, char d, char e, char f,char g);
	string(char a, char b, char c, char d, char e, char f,char g,char h);
	char& operator []( int index);
	const string& operator =(const string & str);
	const string& operator =(const char *s);
	const string& operator =(char ch);
	const string& operator +=(const string &rhs);
	const string& operator +=(const char *s);
	const string& operator +=(char ch);
};

string::string()
{
	len=0;
	str=new char[1];
	str[0]=0;
}

string::string(int size)
{
	len=size;
	str=new char[len+1];
	str[len]=0;
}

string::string(const char *s)
{
	len=slen(s);
	str=new char[len+1];
	scpy(str,s,len);
	str[len]=0;
}
string::string(const string & src) //this is necessary to pass the struct!!!
{
    len=src.len;
    str=new char[len+1];
    scpy(str,src.str,src.len);
	str[len]=0;
}

string::string(char a)
{
	len=1;
	str=new char[len+1];
	str[0]=a;
	str[len]=0;
}

string::string(char a, char b)
{
	len=2;
	str=new char[len+1];
	str[0]=a;
	str[1]=b;
	str[len]=0;
}

string::string(char a, char b, char c)
{
	len=3;
	str=new char[len+1];
	str[0]=a;
	str[1]=b;
	str[2]=c;
	str[len]=0;
}

string::string(char a, char b, char c, char d)
{
	len=4;
	str=new char[len+1];
	str[0]=a;
	str[1]=b;
	str[2]=c;
	str[3]=d;
	str[len]=0;
}

string::string(char a, char b, char c, char d, char e)
{
	len=5;
	str=new char[len+1];
	str[0]=a;
	str[1]=b;
	str[2]=c;
	str[3]=d;
	str[4]=e;
	str[len]=0;
}

string::string(char a, char b, char c, char d, char e, char f)
{
	len=6;
	str=new char[len+1];
	str[0]=a;
	str[1]=b;
	str[2]=c;
	str[3]=d;
	str[4]=e;
	str[5]=f;
	str[len]=0;
}

string::string(char a, char b, char c, char d, char e, char f,char g)
{
	len=7;
	str=new char[len+1];
	str[0]=a;
	str[1]=b;
	str[2]=c;
	str[3]=d;
	str[4]=e;
	str[5]=f;
	str[6]=g;
	str[len]=0;
}

string::string(char a, char b, char c, char d, char e, char f,char g,char h)
{
	len=8;
	str=new char[len+1];
	str[0]=a;
	str[1]=b;
	str[2]=c;
	str[3]=d;
	str[4]=e;
	str[5]=f;
	str[6]=g;
	str[7]=h;
	str[len]=0;
}

string::~string()
{
	delete[] str;
}

char& string::operator[](int index)
{
	if(index<len) return str[index];
	else return str[len];
}

const string& string::operator =(const string &rhs)
{
	delete[] str;
	len=rhs.len;
	str=new char[len+1];
	scpy(str,rhs.str,rhs.len);
	str[len]=0;
	return *this;
}

const string& string::operator =(const char *s)
{
	delete[] str;
	len=slen(s);
	str=new char[len+1];
	scpy(str,s,len);
	str[len]=0;
	return *this;
}

const string& string::operator =(char ch)
{
	delete[] str;
	len=1;
	str=new char[len+1];
	str[0]=ch;
	str[1]=0;
	return *this;
}

const string& string::operator +=(const string &rhs)
{
	int newlen=len+rhs.len;
	char *temp=new char[len+1];
	scpy(temp,str,len+1);
	delete[] str;
	str=new char[newlen+1];
	scpy(str,temp,len);
	delete[] temp;
	scat(str,rhs.str,len,rhs.len);
	len=newlen;
	str[len]=0;
	return *this;
}

const string& string::operator +=(const char *s)
{
	string temp;
	temp=s;
	*this += temp;
	return *this;
}

const string& string::operator +=(char ch)
{
    string temp;
    temp = ch;
    *this += temp;
    return *this;
}

string operator +(const string & lhs, const string & rhs)
{
	string result;
	result=lhs;
	result+=rhs;
	return result;
}

string operator +(char ch,const string &rhs)
{
	string result(rhs.len+1);
	scat(result.str,rhs.str,1,rhs.len);
	result.str[0]=ch;
	return result;
}

string operator +(const string &lhs, char ch)
{
	string result(lhs.len+1);
	scpy(result.str,lhs.str,lhs.len);
	result[result.len-1]=ch;
	return result;
}

string operator +(const string &lhs, char *s)
{
	string result;
	string temp;
	temp=s;
	result=lhs;
	result+=temp;
	return result;
}

string operator +(char *s, const string &rhs)
{
	string result;
	result=s;
	result+=rhs;
	return result;
}

void dispstr(string src)
{
	for(int x=0;x<src.len;x++)
	{
		printf("%u ",src[x]);
	}
	printf("\n");
}
